var webScoketConut = 0;

/** ****************begin：消息处理************************** */
var remotewebsocket; // websocket实例
var lockReconnect = false; // 避免重复连接


var wsUrlweb = 'ws://mq.do-ok.com:6811';
var moniter = '';
var webscoketSend = 2;

var schoolCode = "3702034001"

var deviceInfo = "";

function UUID() {
  var s = [];
  var hexDigits = "0123456789abcdef";
  for (var i = 0; i < 36; i++) {
    s[i] = hexDigits.substr(Math.floor(Math.random() * 0x10), 1);
  }
  s[14] = "4";
  s[19] = hexDigits.substr((s[19] & 0x3) | 0x8, 1);

  s[8] = s[13] = s[18] = s[23] = "-";

  var uuid = s.join("");
  return uuid;
}

var uuid = UUID();

function demo(jsons, el) {
  for (var i = 0; i < jsons.length; i++) {
    var index = 0;
    for (var x in jsons[i]) {
      var thisJson = jsons[i][x];
      if (index == 0) {
        var ths = '';
        for (var vn in thisJson) {
          ths += '<th style="padding:0 10px;border-right:1px solid #f2f2f2">' + vn + '</th>';
        }
        el.append('<thead><tr style="padding:0 10px;border-right:1px solid #f2f2f2">' + ths + '</tr></thead>');
      }
      var thsTbody = '';
      for (var vn in thisJson) {
        thsTbody += '<td style="padding:0 10px;border-right:1px solid #f2f2f2">' + thisJson[vn] + '</td>'
      }
      el.append('<tr>' + thsTbody + '</tr>')
      index++;
    }
  }
}

var linkmsgWeb = {
  "code": schoolCode,
  "type": "system",
  "subtype": "linkmsg",
  "clienttype": "device_view",
  "sender": uuid,
  "receiver": "mina",
  "body": "{}"
};
var heartmsgWeb = {
  "code": schoolCode,
  "type": "system",
  "subtype": "heartmsg",
  "clienttype": "device_view",
  "sender": uuid,
  "receiver": "mina",
  "body": "{}"
};
var equipmentmsgWeb = {
  "code": schoolCode,
  "type": "command",
  "subtype": "statusmsg",
  "clienttype": "device_view",
  "sender": uuid,
  "receiver": "mina",
  "body": {"datas":[{"deviceNo":"2852F90044A3"}]}
};
function createWebSocketWeb(url) {
  try {
    remotewebsocket = new WebSocket(url);
    initEventHandleWeb();
  } catch (e) {
    reconnectWeb(url);
  }
}

function initEventHandleWeb() {
  remotewebsocket.onclose = function () {
    reconnectWeb(wsUrlweb);
  };
  remotewebsocket.onerror = function () {
    reconnectWeb(wsUrlweb);
  };
  remotewebsocket.onopen = function () {
    // 心跳检测重置
    heartCheckWeb.reset().start();
    remotewebsocket.send("@" + JSON.stringify(linkmsgWeb) + "%");
  };
  remotewebsocket.onmessage = function (event) {
    // 如果获取到消息，心跳检测重置，拿到任何消息都说明当前连接是正常的
    heartCheckWeb.reset().start();
    var message = event.data.replace("@", "").replace("%", "");
		console.log(JSON.parse(message)); // 打印mina消息
    try {
      var message = JSON.parse(message);
      var type = message.type;
      var subtype = message.subtype;
      var body = message.body;
      switch (type) {
        case 'sync_data': // 数据同步消息
          if (subtype == 'download') { // 处理下载数据消息
          }
          break;
        case 'im': // 处理即时消息
          break;
        case 'reply': // 处理mina响应
          switch (subtype) {
            case 'statusmsg': // 设备状态信息
              var devices = body.datas
              console.log(body)
			  deviceInfo = devices;
              // devices数据结构如下：
              //{
              //  deviceNo: "B51A60755B8824F73874AF89DF544D7A6" // 设备mac地址
              //  status: "1" // 设备连接状态（"0"-离线，"1"-在线，"2"-异常）
              //}
              break;
          }
          break;
        case 'command':
          switch (subtype) {
            case 'localdata':
              
              break;
            case 'screenshot':
              
              break;
          }
        default:
          console.log("没有匹配的消息类型");
      }
    } catch (e) {
      console.log("收到的消息不是json字符串");
    }
  }
}

function reconnectWeb(url) {
  webScoketConut++;
  console.log('chonglian ')
  if (lockReconnect) return;
  lockReconnect = true;
  // 没连接上会一直重连，设置延迟避免请求过多
  setTimeout(function () {
    createWebSocketWeb(url);
    lockReconnect = false;
  }, 2000);
}

// 心跳检测
var heartCheckWeb = {
  timeout: 60000, // 60秒
  timeoutObj: null,
  serverTimeoutObj: null,
  reset: function () {
    clearTimeout(this.timeoutObj);
    clearTimeout(this.serverTimeoutObj);
    return this;
  },
  start: function () {
    var self = this;
    this.timeoutObj = setTimeout(function () {
      // 这里发送一个心跳，后端收到后，返回一个心跳消息，
      // onmessage拿到返回的心跳就说明连接正常
      remotewebsocket.send("@" + JSON.stringify(heartmsgWeb) + "%");
      self.serverTimeoutObj = setTimeout(function () { // 如果超过一定时间还没重置，说明后端主动断开了
        remotewebsocket.close(); // 如果onclose会执行reconnect，我们执行ws.close()就行了.如果直接执行reconnect // 会触发onclose导致重连两次
      }, self.timeout)
    }, this.timeout)
  }
}

function getEquipmentStatus(datas){
	// equipmentmsgWeb.body = {"datas":datas}
	console.log(equipmentmsgWeb)
	remotewebsocket.send("@" + JSON.stringify(equipmentmsgWeb) + "%");
}

function getDeviceInfo(){
	return deviceInfo;
}

createWebSocketWeb(wsUrlweb);

var now = new Date();
window.setInterval(function () {
  now = new Date();
}, 1000);

//定义时间格式，获取当前时间
function formatDates(date) {
  var myyear = date.getFullYear();
  var mymonth = date.getMonth() + 1;
  var myweekday = date.getDate();
  var hour = date.getHours();
  var minute = date.getMinutes();
  var second = date.getSeconds();
  if (mymonth < 10) {
    mymonth = "0" + mymonth;
  }
  if (myweekday < 10) {
    myweekday = "0" + myweekday;
  }
  if (hour < 10) {
    hour = "0" + hour;
  }
  if (minute < 10) {
    minute = "0" + minute;
  }
  if (second < 10) {
    second = "0" + second;
  }
  return (myyear + "-" + mymonth + "-" + myweekday + ' ' + hour + ':' + minute + ':' + second);
  //  return (myyear + "年" + mymonth + "月" + myweekday + "日");
}

export default  {
	schoolCode,
	getEquipmentStatus,
	deviceInfo,
	getDeviceInfo
}